//Behaviour.cpp

//This is the implementation file for the behaviour.

#include "Behaviour.h"
#include <stdlib.h>

//Paparazzi (def. Italian for 'annoying fly')
//These 'paparazzi' swarm around the first royal blue object in the list.
//If there is no blue object they swarm about the item after themself in the list.
status_t Behaviour(const BList *prev, const BList *next, int32 index, BList *children)
{
#if __INTEL__
	const int32 BLUE = 0xFFFF0000;	//ABGR
#endif

#if __POWERPC__
	const int32 BLUE = 0x0000FFFF;	//RGBA
#endif

	BMessage *entity = (BMessage *)prev->ItemAt(index);

	//Get the entities attributes
	float x = entity->FindFloat("x-pos");
	float y = entity->FindFloat("y-pos");
	float z = entity->FindFloat("z-pos");
	int32 x_dir = entity->FindInt32("x-dir");
	int32 y_dir = entity->FindInt32("y-dir");
	int32 z_dir = entity->FindInt32("z-dir");

	entity = (BMessage *)next->ItemAt(index);
	if (x_dir == 0)
		entity->AddInt32("x-dir", 1);
	if (y_dir == 0)
		entity->AddInt32("y-dir", -1);
	if (z_dir == 0)
		entity->AddInt32("z-dir", 1);

	//Find the blue
	BMessage *diana;
	bool found_blue = false;
	int32 i;

	int32 count = prev->CountItems();
	for(i = 0; i < count; i++)
	{
		diana = (BMessage *)prev->ItemAt(i);

		if (diana->FindInt32("color") == BLUE)
		{
			found_blue = true;
			break;
		}
	}

	if (!found_blue)
	{
		i = (index + 1) % count;
		diana = (BMessage *)prev->ItemAt(i);
	}

	//Get the postion
	float di_x = diana->FindFloat("x-pos");
	float di_y = diana->FindFloat("y-pos");
	float di_z = diana->FindFloat("z-pos");

	//Swarm
	const int32 radius = 6;
	if (x_dir == 1)
	{
		if (x < di_x + radius)
			x = x + 1;//rand()/16348;
		else
		{
			x_dir = -1;
			x = x - 1;//rand()/16348;
		}
	}
	else
	{
		if (x > di_x - radius)
			x = x - 1;//rand()/16348;
		else
		{
			x_dir = 1;
			x = x + 1;//rand()/16348;
		}
	}

	//Y
	if (y_dir == 1)
	{
		if (y < di_y + radius)
			y = y + 1;//rand()/16348;
		else
		{
			y_dir = -1;
			y = y - 1;//rand()/16348;
		}
	}
	else
	{
		if (y > di_y - radius)
			y = y - 1;//rand()/16348;
		else
		{
			y_dir = 1;
			y = y + 1;//rand()/16348;
		}
	}

	//Z
	if (z_dir == 1)
	{
		if (z < di_z + radius)
			z = z + 1;//rand()/16348;
		else
		{
			z_dir = -1;
			z = z - 1;//rand()/16348;
		}
	}
	else
	{
		if (z > di_z - radius)
			z = z - 1;//rand()/16348;
		else
		{
			z_dir = 1;
			z = z + 1;//rand()/16348;
		}
	}
	
	//Write the changes back to our archive
	entity->ReplaceFloat("x-pos", x);
	entity->ReplaceFloat("y-pos", y);
	entity->ReplaceFloat("z-pos", z);
	entity->ReplaceInt32("x-dir", x_dir);
	entity->ReplaceInt32("y-dir", y_dir);
	entity->ReplaceInt32("z-dir", z_dir);
	
	return B_OK;
}

//don't forget to go Window->Settings->x86 Project and change the default file name
