//Initialise.cpp

//This is the implementation file for the initialiser.

#include <stdlib.h>
#include <OS.h>
#include <Message.h>
#include "Initialise.h"

//Entities are represented by BMessages which contain all the attributes of a given entity.
//Initialisers are used to give entities some default attributes.

status_t Initialise(BMessage *entity)
{
	float x;
	float y;
	float z;
	
	//Generate some random integer values between (-20, -20, -20) and (20, 20, 20)
	srand(system_time());
	x = (rand() % 40) - 20;
	y = (rand() % 40) - 20;
	z = (rand() % 40) - 20;

	//Give the entity it's new attributes
	if (entity->HasFloat("x-pos"))
		entity->ReplaceFloat("x-pos", x);
	else
		entity->AddFloat("x-pos", x);

	if (entity->HasFloat("y-pos"))
		entity->ReplaceFloat("y-pos", y);
	else
		entity->AddFloat("y-pos", y);

	if (entity->HasFloat("y-pos"))
		entity->ReplaceFloat("y-pos", z);
	else
		entity->AddFloat("y-pos", z);

	return B_OK;
}

//don't forget to go Window->Settings->x86 Project and change the default file name
