//Initialise.cpp

//This is the implementation file for the initialiser.

#include <stdlib.h>
#include <Message.h>
#include "Initialise.h"

//Entities are represented by BMessages which contain all the attributes of a given entity.
//Initialisers are used to give entities some default attributes.

status_t Initialise(BMessage *entity)
{
	const int32 SIZE = 25;

	float x;
	float y;
	float z;
	
	//Generate some random integer values between (0, 0, 0) and (29, 29, 29)
	x = rand() % SIZE;
	y = rand() % SIZE;
	z = rand() % SIZE;

	//Give the entity it's new attributes
	if (entity->HasFloat("x-pos"))
		entity->ReplaceFloat("x-pos", x);
	else
		entity->AddFloat("x-pos", x);

	if (entity->HasFloat("y-pos"))
		entity->ReplaceFloat("y-pos", y);
	else
		entity->AddFloat("y-pos", y);

	if (entity->HasFloat("z-pos"))
		entity->ReplaceFloat("z-pos", z);
	else
		entity->AddFloat("z-pos", z);

	return B_OK;
}

//don't forget to go Window->Settings->x86 Project and change the default file name
