//entityManager.h
//Copyright © 1998, Paul Yu 

#ifndef _entityManager_h_
#define _entityManager_h_

#include <Handler.h>
#include "addonManager.h"

class entityManager : public BHandler
{
	public:
		entityManager();
		~entityManager();
		void MessageReceived(BMessage *msg);
		void Buffer();

	protected:		
		void Reset();
		void Increment();
		status_t Draw();

		void SetBufferSize(int32 size);
		void BaselineToBoard(BList *board);

		status_t Initialise(const char *algorithm, BMessage *entity);
		status_t Behaviour(const char *algorithm, int32 index, BList *prev, BList *next, BList *children);
		status_t Draw(const char *algorithm, BMessage *entity);
		void ClearBoard(BList *board);
		void CopyBoard(BList *src, BList *dst);

		addonManager *mAddons;	
		BMessage *mBaseline;	//the raw entities before initialisation

		int32 mBufferSize;
		BList mBuffers;
		sem_id mReadyBuffers;
		sem_id mEmptyBuffers;

		int32 mBufferCursor;
		int32 mDisplayCursor;
		BList *mDisplayBoard;
		
		int32 mGeneration;
		thread_id mBufferThread;
};

#endif
