//message_protocols.h

#ifndef _message_protocols_h_
#define _message_protocols_h_

//constants ('abcd') composed entirely of capitals and underscores
//are reserved by BeOS, so don't use them. Indentifiers (B_OK) prefixed
//with "B_" are also reserved by BeOS.

//Common
const uint32 SET_CONTEXT = 'setc';

//Arena Manager
const uint32 DRAW_ARENA = 'darn';
const uint32 RESTART = 'rsrt';
const uint32 SINGLE_STEP = 'step';
const uint32 CONTINUOUS = 'cont';

const uint32 X_SPIN_STOP = 'xSTP';
const uint32 X_SPIN_POS = 'xPOS';
const uint32 X_SPIN_NEG = 'xNEG';
const uint32 Y_SPIN_STOP = 'ySTP';
const uint32 Y_SPIN_POS = 'yPOS';
const uint32 Y_SPIN_NEG = 'yNEG';
const uint32 Z_SPIN_STOP = 'zSTP';
const uint32 Z_SPIN_POS = 'zPOS';
const uint32 Z_SPIN_NEG = 'zNEG';

//Entity Manager
const uint32 DRAW_ENTITIES = 'drnt';
const uint32 RESET = 'rset';
const uint32 INCREMENT = 'ncmt';
const uint32 SET_BUFFER_SIZE = 'sbsz';
const uint32 SET_BASELINE = 'sbln';
const uint32 GET_BASELINE = 'gbln';

//Entity Editor
const uint32 EDIT = 'edit';
const uint32 NEW = 'newe';
const uint32 OPEN = 'open';
const uint32 SAVE = 'save';
const uint32 SAVEAS = 'svas';

//Editor
const uint32 ADD = 'adde';
const uint32 DELETE = 'dele';
const uint32 UPDATE = 'updt';
const uint32 DUPLICATE = 'dupe';

#endif
