//Behaviour.cpp

//This is the implementation file for the behaviour.

#include "Behaviour.h"
#include <stdlib.h>

//Entities are represented by BMessages which contain all the attributes of a given entity.
//The behaviour algorithm can inspect the environment before deciding what changes to make
//to the attributes.

//BList *prev
//This is a list of pointers to BMessages. Each represents the state of an entity as it
//appeared at the end of the previous generation. This is the "environment".

//BList *next
//This is a list of entities as they should be in the next generation.
//Initially this list is a copy of "prev". The simulator inspects each entity to see what
//behaviours it has. For each behaviour it calls the Behaviour() function of the appropriate
//add-on with the "index" of that entity as a parameter.

//int32 index
//The index of the current entity in the "prev" and "next" lists.
//i.e., current = next->ItemAt(index);

//BList *children
//One possible behaviour is the creation of additional entities. This is done by
//adding the entities (BMessages) to the "children" list.

//A harmless but highly infectuous virus
status_t Behaviour(const BList *prev, const BList *next, int32 index, BList *children)
{
	//Select a random victim
	int32 i = rand() % (next->CountItems());
	BMessage *victim = (BMessage *)next->ItemAt(i);
	
	//Infect if not already infected
	for(int32 j = 0; victim->HasString("behaviours", j); j++)
	{
		if (strcmp("virus", victim->FindString("behaviours", j)) == 0)
			return B_OK;	
	}	
	
	//If we reach here then it doesn't already have the "virus" behaviour
	victim->AddString("behaviours", "virus");	

	return B_OK;
}

//don't forget to go Window->Settings->x86 Project and change the default file name
